<?php
/*  Photoblog for DotClear
 *  Copyright (C) 2005  Julien Mudry
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

$my_name = 'photoblog';
$url = 'tools.php?p=' . $my_name;

$page = !empty($_REQUEST['page']) ? $_REQUEST['page'] : 'main';

$mySubMenu->addItem(__('Photoblog config'), $url, 'tools/photoblog/icon_sm.png', $page == 'main');
$mySubMenu->addItem(__('Recreate thumbnails'), $url . '&amp;page=manage_thumbs', 'tools/photoblog/icon_recycle.png', $page == 'manage_thumbs');
$mySubMenu->addItem(__('Changelog'), $url . '&amp;page=changelog', 'tools/photoblog/icon_log.png', $page == 'changelog');

if ($page == 'manage_thumbs') {
	include dirname(__FILE__) . '/manage_thumbs.php';
	return;
} elseif ($page == 'changelog') {
	include dirname(__FILE__) . '/changelog.php';
	return;
}

include_once(dirname(__FILE__).'/lib.installer.php');

$err = '';

$url_config = 'tools.php?p=blogconf';

$default_nav_thumbs = 3;
$default_thumb_size = 90;
$default_sepia = 2;
$default_now_text = 'Vous &ecirc;tes ici';
$default_same_thumbs = true;

/* Affichage du titre
-------------------------------------------------------- */
buffer::str('<h2><img src="tools/photoblog/icon.png" alt="" />'.__('PhotoBlog').'</h2>');


// Traitement des modifications de la configuration
if (!empty($_POST)) // (isset($_POST['submit']))
{
	$my_config = array();
	$my_config['sp_photo_sepia'] = (integer)trim($_POST['p_photo_sepia']);
	$my_config['sp_archive_month_chrono_order'] = (integer)trim($_POST['p_archive_month_chrono_order']);
	$my_config['sp_archive_cat_chrono_order'] = (integer)trim($_POST['p_archive_cat_chrono_order']);
	$my_config['sp_nav_nb_prev_thumbs'] = (integer)trim($_POST['p_nav_nb_prev_thumbs']);
	$my_config['sp_nav_nb_next_thumbs'] = (integer)trim($_POST['p_nav_nb_next_thumbs']);
	$my_config['sp_thumb_width'] = (integer)trim($_POST['p_thumb_width']);
	$my_config['sp_thumb_height'] = (integer)trim($_POST['p_thumb_height']);
	$my_config['sp_now_text'] = htmlentities(trim($_POST['p_now_text']));
	$my_config['sp_same_thumbs'] = (integer)(isset($_POST['p_same_thumbs'])?1:-1);
	$my_config['sp_photo_sepia_nav'] = (integer)trim($_POST['p_photo_sepia_nav']);
	$my_config['sp_thumb_width_nav'] = (integer)trim($_POST['p_thumb_width_nav']);
	$my_config['sp_thumb_height_nav'] = (integer)trim($_POST['p_thumb_height_nav']);

	if (installer::savePluginConfig($my_name, $my_config)) {		
		$res = __('Configuration file successfully updated.');
		if (defined('DC_UPDATE_FILE_W') && DC_UPDATE_FILE_W) {
			files::touch(DC_UPDATE_FILE,time());
		}
	} else {
		$err = __('Unable to save configuration');
	}
}
// Vrification de l'installation et rcupration de la configuration
//else
//{
	if (($err = installer::checkPluginShareDir($my_name))) {
		$err = sprintf(__('Unavailable %s/ directory in share/. You may create it manually.'),$my_name);
	}
	$my_config = installer::loadPluginConfig($my_name);
	$p_photo_sepia = $my_config['sp_photo_sepia'];
	$p_archive_month_chrono_order = $my_config['sp_archive_month_chrono_order'];
	$p_archive_cat_chrono_order = $my_config['sp_archive_cat_chrono_order'];
	$p_nav_nb_prev_thumbs = $my_config['sp_nav_nb_prev_thumbs'];
	$p_nav_nb_next_thumbs = $my_config['sp_nav_nb_next_thumbs'];
	$p_thumb_width = $my_config['sp_thumb_width'];
	$p_thumb_height = $my_config['sp_thumb_height'];
	$p_now_text = isset($my_config['sp_now_text']) ? $my_config['sp_now_text'] : '';
	$p_same_thumbs = isset($my_config['sp_same_thumbs']) ? $my_config['sp_same_thumbs'] : '';
	$p_photo_sepia_nav = isset($my_config['sp_photo_sepia_nav']) ? $my_config['sp_photo_sepia_nav'] : $my_config['sp_photo_sepia'];
	$p_thumb_width_nav = isset($my_config['sp_thumb_width_nav']) ? $my_config['sp_thumb_width_nav'] : $my_config['sp_thumb_width'];
	$p_thumb_height_nav = isset($my_config['sp_thumb_height_nav']) ? $my_config['sp_thumb_height_nav'] : $my_config['sp_thumb_height'];

	// Valeurs par dfaut
	if (empty($p_nav_nb_prev_thumbs)) { $p_nav_nb_prev_thumbs = $default_nav_thumbs; }
	if (empty($p_nav_nb_next_thumbs)) { $p_nav_nb_next_thumbs = $default_nav_thumbs; }
	if (empty($p_thumb_width)) { $p_thumb_width = $default_thumb_size; }
	if (empty($p_thumb_height)) { $p_thumb_height = $default_thumb_size; }
	if (empty($p_now_text)) { $p_now_text = $default_now_text; }
	if (empty($p_same_thumbs)) { $p_same_thumbs = $default_same_thumbs; }
//}

if (!extension_loaded('gd')) {
	if ($err != '') {
		$err .= '</p><p>';
	}
	$err .= __("The GD library doesn't seem to be present in your PHP configuration. Please activate it, otherwise you won't have any thumbnails.");
}

/* Affichage
-------------------------------------------------------- */

// Affichage d'un message d'erreur ou d'tat si dfini.
if (!empty($res)) {
	buffer::str('<div class="erreur"><p>'.$res.'</p></div>');	
}
if(!empty($err))
{
	buffer::str('<div class="erreur"><p><strong>'.__('Error(s)').' :</strong></p><p>' . $err . '</p></div>');
}

buffer::str(
	'<script type="text/javascript">'."\n".
	"<!--\n".
	"function disable (fieldsetName, disableIt) {\n".
	"	var e, i = 0;\n".
	"	while (e = document.getElementById(fieldsetName).getElementsByTagName('LABEL')[i++]) {\n".
	"		if (disableIt) {\n".
	"			e.className = 'disable';\n".
	"			e.lastChild.disabled = true;\n".
	"			e.lastChild.value = '';\n".
	"		} else {\n".
	"			e.className = '';\n".
	"			e.lastChild.disabled = false;\n".
	"		}\n".
	"	}\n".
	"}\n".
	"// if (document.getElementById) onload = disable('thumb_nav', " . ($p_same_thumbs > 0 ? 'true' : 'false') . ");\n".
	"// -->\n".
	"</script>\n");

buffer::str(
	'<form action="'.$url.'" method="post" id="photo_config" name="photo_config">'.
	
	'<fieldset class="clear" id="thumb_config" name="thumb_config">'.
	'<legend>'.__('Base configuration').'</legend>'.
	'<p class="field"><label for="p_nav_nb_prev_thumbs"><strong>'.
	__('Number of thumbnails to display for access to previous posts').'&nbsp;:</strong> ' . '</label>' .
	form::field('p_nav_nb_prev_thumbs', 1, '', (integer) $p_nav_nb_prev_thumbs).
	'</p>'.
	'<p class="field"><label for="p_nav_nb_next_thumbs"><strong>'.
	__('Number of thumbnails to display for access to next posts').'&nbsp;:</strong> ' . '</label>' .
	form::field('p_nav_nb_next_thumbs', 1, '', (integer) $p_nav_nb_next_thumbs).
	'</p>'.
	'<p class="field">'.
	'<label for="p_same_thumbs" class="float"><strong>'.
	__('Use the same thumbnails for archives and navigation').'</strong></label>'.
	'<input type="checkbox" name="p_same_thumbs" value="p_same_thumbs" id="p_same_thumbs"' .
	($p_same_thumbs > 0 ? ' checked="checked"' : '') . ' />' . 
	'</p>'.
	'<fieldset style="width: 40%; float: left;" class="clear">'.
	'<legend>'.__('Thumbnails for archives').'</legend>'.
	'<p class="field"><label for="p_photo_sepia"><strong>'.
	__('Sepia toning for thumbnails').'&nbsp;: </strong>' . helpLink('index&amp;plugin=photoblog', 'sepia_tone') . '</label>'.
	form::combo('p_photo_sepia', array(__('Color')=>0, __('Black and white')=>1, __('Sepia #1')=>2, __('Sepia #2')=>3, __('Sepia #3')=>4, __('Selenium')=>5, __('Silver')=>6, __('Cyanotype')=>7, __('Platinum')=>8, __('Palladium')=>9, __('Silver gelatin')=>10), (integer) $p_photo_sepia).
	'</p>'.
	'<p class="field"><label for="p_thumb_width"><strong>'.
	__('Width of thumbnails (in pixels)').'&nbsp;:</strong> ' . '</label>' .
	form::field('p_thumb_width', 2, '', (integer) $p_thumb_width).
	'</p>'.
	'<p class="field"><label for="p_thumb_height"><strong>'.
	__('Height of thumbnails (in pixels)').'&nbsp;:</strong> ' . '</label>' .
	form::field('p_thumb_height', 2, '', (integer) $p_thumb_height).
	'</p>'.
	'</fieldset>'.
	'<fieldset style="width: 40%; float: right;" id="thumb_nav" name="thumb_nav">'.
	'<legend>'.__('Thumbnails for navigation').'</legend>'.
	'<p class="field"><label for="p_photo_sepia_nav"><strong>'.
	__('Sepia toning for thumbnails').'&nbsp;: </strong>' . helpLink('index&amp;plugin=photoblog', 'sepia_tone') . '</label>'.
	form::combo('p_photo_sepia_nav', array(__('Color')=>0, __('Black and white')=>1, __('Sepia #1')=>2, __('Sepia #2')=>3, __('Sepia #3')=>4, __('Selenium')=>5, __('Silver')=>6, __('Cyanotype')=>7, __('Platinum')=>8, __('Palladium')=>9, __('Silver gelatin')=>10), (integer) $p_photo_sepia_nav).
	'</p>'.
	'<p class="field"><label for="p_thumb_width_nav"><strong>'.
	__('Width of thumbnails (in pixels)').'&nbsp;:</strong> ' . '</label>' .
	form::field('p_thumb_width_nav', 2, '', (integer) $p_thumb_width_nav).
	'</p>'.
	'<p class="field"><label for="p_thumb_height"><strong>'.
	__('Height of thumbnails (in pixels)').'&nbsp;:</strong> ' . '</label>' .
	form::field('p_thumb_height_nav', 2, '', (integer) $p_thumb_height_nav).
	'</p>'.
	'</fieldset>'.
	'</fieldset>'.

	'<fieldset class="clear">' .
	'<legend>' . __('Miscellanous') . '</legend>' .
	'<p class="field"><label for="p_now_text"><strong>' . 
	__('Text to display on the current thumbnail in navigation') . '&nbsp;:</strong></label>' .
	form::field('p_now_text', 30, '', $p_now_text) .
	'</p></fieldset>' .

	'<fieldset class="clear">' .
	'<legend>' . __('Archives configuration') . '</legend>' .
	'<p class="field"><label for="p_archive_month_chrono_order"><strong>' .
	__('Sort posts in monthly archive from oldest to newest') . '&nbsp;:</strong></label>' .
	form::combo('p_archive_month_chrono_order', array(__('yes')=>1, __('no')=>0), (integer) $p_archive_month_chrono_order) . '</p>' .
	'<p class="field"><label for="p_archive_cat_chrono_order"><strong>' .
	__('Sort posts in category archive from oldest to newest') . '&nbsp;:</strong></label>' .
	form::combo('p_archive_cat_chrono_order', array(__('yes')=>1, __('no')=>0), (integer) $p_archive_cat_chrono_order) . '</p>' .
	'</fieldset>' .

	'<p class="field"><input class="submit" type="submit" value="'.__('save').'" /></p>'.
	'<p>'.dcNonce::form().'</p>'.
	'</form>'
);

buffer::str('<h3>' . 
__('DotClear configuration') . '</h3><p>'. __("For correct usage of this plugin, you have to tweak DotClear's configuration.") . ' ' .
sprintf(__('For that, go to the %sDotClear Configuration%s plugin and choose the "Default photo theme" as the blog theme.'), '<a href="'.$url_config.'">', '</a>').
'</p><h3>' . __('Usage') . '</h3><p><ol><li>' .
 __('Upload your pictures to the images directory.') . '</li><li>' . __('Write a post with the desired image in it. (I use the wiki syntax and center the image.)') .
'</li><li>' . __('Save your post.') . '</li></ol></p>');

buffer::str('<h3>' . __('A few notes') . '</h3><p><ul><li>' . 
__("The default photo theme always display both the header and the post content.") . '</li><li>' .
__('The photoblog plugin always uses the first image it finds in the post (be it in the header or in the content) as basis for the thumbnail') . '</li><li>' .
sprintf(__("If you change the sepia toning, you'll have to manually delete the generated thumbnails (files having a %s suffix in your images directory) or use the %s page."), '<kbd>photobwTN__</kbd>', '<kbd>' . __('Recreate thumbnails') . '</kbd>')
. '</li></ul></p>');

buffer::str('<h3>' . __('Known bugs') . '</h3><p><ul><li>' . 
__("The default photo theme does not look exactly the same using Firefox or Internet Explorer. Be assured that the intended look is the one seen using Firefox.") . '</li><li>' . __('Every post has to have a title. This limitation is due to DotClear.') . '</li></ul></p>');

buffer::str('<div class="copyright"><h3>' . __('Copyright information') . '</h3><p>' . sprintf(__('The icon used for this plugin is %s 2004 by %s.'), '&copy;', ' <a href="http://www.miloszwl.com/">Miloszwl</a>') . ' ' . 
	sprintf(__('All the code is %s 2005 by %s and distributed under the terms of the GPL license.'), '&copy;', '<a href="http://www.mudry.org/">julien mudry</a>') . '</p><p>' . sprintf(__('The default photo theme was made by %s and julien mudry, based on previous work by Samuel Latchman and Olivier Meunier.'), '<a href="http://www.kozlika.org/kozeries/">Kozlika</a>') . '</p></div>');
?>
